<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AbreEmpresaPrimavera StructType
 * @subpackage Structs
 */
class AbreEmpresaPrimavera extends AbstractStructBase
{
    /**
     * The empresa
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $empresa;
    /**
     * Constructor method for AbreEmpresaPrimavera
     * @uses AbreEmpresaPrimavera::setEmpresa()
     * @param string $empresa
     */
    public function __construct($empresa = null)
    {
        $this
            ->setEmpresa($empresa);
    }
    /**
     * Get empresa value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEmpresa()
    {
        return isset($this->empresa) ? $this->empresa : null;
    }
    /**
     * Set empresa value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $empresa
     * @return \StructType\AbreEmpresaPrimavera
     */
    public function setEmpresa($empresa = null)
    {
        // validation for constraint: string
        if (!is_null($empresa) && !is_string($empresa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($empresa)), __LINE__);
        }
        if (is_null($empresa) || (is_array($empresa) && empty($empresa))) {
            unset($this->empresa);
        } else {
            $this->empresa = $empresa;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AbreEmpresaPrimavera
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
